#ifndef __SSD1963_GUI_H
#define __SSD1963_GUI_H

#include "stm32f4xx.h"
#include "SSD1963.h"
#include "SSD1963_api.h"
#include "SSD1963_font.h"

#include <stdbool.h>

/* RTOS includes. */
#include "Os_Wrap.h"

extern OS_SemaphoreHandle gLCD_Mutex;			//lcd
extern OS_SemaphoreHandle gBmpObj_Mutex;			//ļ

#define LCD_Lock() OS_SemaphoreTake(gLCD_Mutex,OS_MAX_DELAY)
#define LCD_UnLock() OS_SemaphoreGive(gLCD_Mutex)


#define GUI_Line(x0, y0, x1, y1, color) LCD_Lock(); LCD_Line(x0, y0, x1, y1, color); LCD_UnLock();
#define GUI_Circle(cx, cy, r, color, fill) LCD_Lock(); LCD_Circle(cx, cy, r, color, fill); LCD_UnLock();

#define GUI_DisplayBMP_FAT(Xpos, Ypos, BmpName) LCD_Lock(); LCD_DisplayBMP_FAT(Xpos, Ypos, BmpName); LCD_UnLock();

#endif /* __SSD1963_GUI_H */
